<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Lexis.Noun</span><span>
</span><span id="line-2"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Lexis.Noun.html#Nominal"><span class="hs-identifier">Nominal</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-3"></span><span>    </span><span class="annot"><a href="Lexis.Noun.html#Noun"><span class="hs-identifier">Noun</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span>
</span><span id="line-4"></span><span>    </span><span class="annot"><a href="Lexis.Noun.html#getNoun"><span class="hs-identifier">getNoun</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-5"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-6"></span><span class="hs-keyword">where</span><span>
</span><span id="line-7"></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Features.html"><span class="hs-identifier">Features</span></a></span><span>
</span><span id="line-9"></span><span>
</span><span id="line-10"></span><span class="hs-comment">-- | The EmptyNoun class is used in cases where we want to omit a constituent.</span><span>
</span><span id="line-11"></span><span class="hs-keyword">data</span><span> </span><span id="Nominal"><span class="annot"><a href="Lexis.Noun.html#Nominal"><span class="hs-identifier hs-var">Nominal</span></a></span></span><span>
</span><span id="line-12"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Noun"><span class="annot"><a href="Lexis.Noun.html#Noun"><span class="hs-identifier hs-var">Noun</span></a></span></span><span> </span><span class="annot"><a href="Lexis.Noun.html#Noun"><span class="hs-identifier hs-type">Noun</span></a></span><span>
</span><span id="line-13"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Pronoun"><span class="annot"><a href="Lexis.Noun.html#Pronoun"><span class="hs-identifier hs-var">Pronoun</span></a></span></span><span>
</span><span id="line-14"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="EmptyNoun"><span class="annot"><a href="Lexis.Noun.html#EmptyNoun"><span class="hs-identifier hs-var">EmptyNoun</span></a></span></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081739"><span id="local-6989586621679081741"><span class="annot"><span class="annottext">Nominal -&gt; Nominal -&gt; Bool
(Nominal -&gt; Nominal -&gt; Bool)
-&gt; (Nominal -&gt; Nominal -&gt; Bool) -&gt; Eq Nominal
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Nominal -&gt; Nominal -&gt; Bool
$c/= :: Nominal -&gt; Nominal -&gt; Bool
== :: Nominal -&gt; Nominal -&gt; Bool
$c== :: Nominal -&gt; Nominal -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081732"><span id="local-6989586621679081734"><span id="local-6989586621679081736"><span class="annot"><span class="annottext">Int -&gt; Nominal -&gt; ShowS
[Nominal] -&gt; ShowS
Nominal -&gt; String
(Int -&gt; Nominal -&gt; ShowS)
-&gt; (Nominal -&gt; String) -&gt; ([Nominal] -&gt; ShowS) -&gt; Show Nominal
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Nominal] -&gt; ShowS
$cshowList :: [Nominal] -&gt; ShowS
show :: Nominal -&gt; String
$cshow :: Nominal -&gt; String
showsPrec :: Int -&gt; Nominal -&gt; ShowS
$cshowsPrec :: Int -&gt; Nominal -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-16"></span><span>
</span><span id="line-17"></span><span class="hs-comment">-- | Noun subclasses</span><span>
</span><span id="line-18"></span><span class="hs-keyword">data</span><span> </span><span id="Noun"><span class="annot"><a href="Lexis.Noun.html#Noun"><span class="hs-identifier hs-var">Noun</span></a></span></span><span>
</span><span id="line-19"></span><span>  </span><span class="hs-glyph">=</span><span> </span><span id="Count"><span class="annot"><a href="Lexis.Noun.html#Count"><span class="hs-identifier hs-var">Count</span></a></span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span> </span><span class="annot"><a href="Features.Nominal.html#Number"><span class="hs-identifier hs-type">Number</span></a></span><span>
</span><span id="line-20"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Mass"><span class="annot"><a href="Lexis.Noun.html#Mass"><span class="hs-identifier hs-var">Mass</span></a></span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-21"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Proper"><span class="annot"><a href="Lexis.Noun.html#Proper"><span class="hs-identifier hs-var">Proper</span></a></span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">|</span><span> </span><span id="Anthroponym"><span class="annot"><a href="Lexis.Noun.html#Anthroponym"><span class="hs-identifier hs-var">Anthroponym</span></a></span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-23"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679081723"><span id="local-6989586621679081725"><span class="annot"><span class="annottext">Noun -&gt; Noun -&gt; Bool
(Noun -&gt; Noun -&gt; Bool) -&gt; (Noun -&gt; Noun -&gt; Bool) -&gt; Eq Noun
forall a. (a -&gt; a -&gt; Bool) -&gt; (a -&gt; a -&gt; Bool) -&gt; Eq a
/= :: Noun -&gt; Noun -&gt; Bool
$c/= :: Noun -&gt; Noun -&gt; Bool
== :: Noun -&gt; Noun -&gt; Bool
$c== :: Noun -&gt; Noun -&gt; Bool
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Eq</span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679081717"><span id="local-6989586621679081719"><span id="local-6989586621679081721"><span class="annot"><span class="annottext">Int -&gt; Noun -&gt; ShowS
[Noun] -&gt; ShowS
Noun -&gt; String
(Int -&gt; Noun -&gt; ShowS)
-&gt; (Noun -&gt; String) -&gt; ([Noun] -&gt; ShowS) -&gt; Show Noun
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
showList :: [Noun] -&gt; ShowS
$cshowList :: [Noun] -&gt; ShowS
show :: Noun -&gt; String
$cshow :: Noun -&gt; String
showsPrec :: Int -&gt; Noun -&gt; ShowS
$cshowsPrec :: Int -&gt; Noun -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-24"></span><span>
</span><span id="line-25"></span><span class="hs-comment">-- | Produces the noun's root</span><span>
</span><span id="line-26"></span><span class="annot"><a href="Lexis.Noun.html#getNoun"><span class="hs-identifier hs-type">getNoun</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Lexis.Noun.html#Noun"><span class="hs-identifier hs-type">Noun</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-27"></span><span id="getNoun"><span class="annot"><span class="annottext">getNoun :: Noun -&gt; String
</span><a href="Lexis.Noun.html#getNoun"><span class="hs-identifier hs-var hs-var">getNoun</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Noun.html#Count"><span class="hs-identifier hs-type">Count</span></a></span><span> </span><span id="local-6989586621679081716"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081716"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span class="annot"><span class="annottext">Number
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081716"><span class="hs-identifier hs-var">x</span></a></span><span>
</span><span id="line-28"></span><span class="annot"><a href="Lexis.Noun.html#getNoun"><span class="hs-identifier hs-var">getNoun</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Noun.html#Mass"><span class="hs-identifier hs-type">Mass</span></a></span><span> </span><span id="local-6989586621679081715"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081715"><span class="hs-identifier hs-var">x</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081715"><span class="hs-identifier hs-var">x</span></a></span><span>
</span><span id="line-29"></span><span class="annot"><a href="Lexis.Noun.html#getNoun"><span class="hs-identifier hs-var">getNoun</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Noun.html#Proper"><span class="hs-identifier hs-type">Proper</span></a></span><span> </span><span id="local-6989586621679081714"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081714"><span class="hs-identifier hs-var">x</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081714"><span class="hs-identifier hs-var">x</span></a></span><span>
</span><span id="line-30"></span><span class="annot"><a href="Lexis.Noun.html#getNoun"><span class="hs-identifier hs-var">getNoun</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.Noun.html#Anthroponym"><span class="hs-identifier hs-type">Anthroponym</span></a></span><span> </span><span id="local-6989586621679081713"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081713"><span class="hs-identifier hs-var">x</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679081713"><span class="hs-identifier hs-var">x</span></a></span><span>
</span><span id="line-31"></span></pre></body></html>